#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%global		__python	/usr/bin/python3
#-----------------------------------------------------------------------------
Name		:	dlib
Version		:	19.24.02330e0
Release		:	17.2.0.rel%{?dist}
Summary		:	A modern C++ toolkit containing machine learning algorithms

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	boost
URL		:	http://dlib.net
			#git archive --format tar --prefix=dlib-19.24.02330e0/ HEAD | gzip > ../dlib-19.24.02330e0.tar.gz

Source0		:	%{name}-%{version}.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	boost-devel
BuildRequires	:	cmake
BuildRequires	:	gcc-c++

#-----------------------------------------------------------------------------
%description
Dlib is a general purpose cross-platform open source
software library written in the C++ programming language.
Its design is heavily influenced by ideas from design
by contract and component-based software engineering.
It contains components for dealing with networking,
threads, graphical user interfaces, data structures,
linear algebra, machine learning, image processing,
data mining, XML and text parsing, numerical optimization,
Bayesian networks, and numerous other tasks.

#-----------------------------------------------------------------------------
%files
%defattr(-,root,root,-)
%license dlib/LICENSE.txt
%{_libdir}/lib%{name}.so.19*

#=============================================================================
%package		devel
Summary		:	Development files for dlib

#-----------------------------------------------------------------------------
Requires	:	%{name}	= %{version}-%{release}

#----------------------------------------------------------------------------
%description		devel
Dlib is a general purpose cross-platform open source
software library written in the C++ programming language.
This package contains development files for the library.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-, root,root,-)
%{_includedir}/%{name}/*.h
%{_includedir}/%{name}/any/*.h
%{_includedir}/%{name}/array/*.h
%{_includedir}/%{name}/array2d/*.h
%{_includedir}/%{name}/base64/*.h
%{_includedir}/%{name}/bayes_utils/*.h
%{_includedir}/%{name}/bigint/*.h
%{_includedir}/%{name}/binary_search_tree/*.h
%{_includedir}/%{name}/bit_stream/*.h
%{_includedir}/%{name}/bits/*.h
%{_includedir}/%{name}/bound_function_pointer/*.h
%{_includedir}/%{name}/bridge/*.h
%{_includedir}/%{name}/bsp/*.h
%{_includedir}/%{name}/byte_orderer/*.h
%{_includedir}/%{name}/clustering/*.h
%{_includedir}/%{name}/cmake_utils/*.cmake
%{_includedir}/%{name}/cmd_line_parser/*.h
%{_includedir}/%{name}/compress_stream/*.h
%{_includedir}/%{name}/conditioning_class/*.h
%{_includedir}/%{name}/config_reader/*.h
%{_includedir}/%{name}/control/*.h
%{_includedir}/%{name}/cpp_pretty_printer/*.h
%{_includedir}/%{name}/cpp_tokenizer/*.h
%{_includedir}/%{name}/crc32/*.h
%{_includedir}/%{name}/cuda/*.h
%{_includedir}/%{name}/data_io/*.h
%{_includedir}/%{name}/dir_nav/*.h
%{_includedir}/%{name}/directed_graph/*.h
%{_includedir}/%{name}/disjoint_subsets/*.h
%{_includedir}/%{name}/dnn/*.h
%{_includedir}/%{name}/entropy_decoder/*.h
%{_includedir}/%{name}/entropy_decoder_model/*.h
%{_includedir}/%{name}/entropy_encoder/*.h
%{_includedir}/%{name}/entropy_encoder_model/*.h
%{_includedir}/%{name}/external/cblas/*.h
%{_includedir}/%{name}/external/libjpeg/*.h
%{_includedir}/%{name}/external/libpng/*.h
%{_includedir}/%{name}/external/pybind11/include/pybind11/*.h
%{_includedir}/%{name}/external/pybind11/include/pybind11/detail/*.h
%{_includedir}/%{name}/external/pybind11/include/pybind11/stl/*.h
%{_includedir}/%{name}/external/pybind11/tools/*.cmake
%{_includedir}/%{name}/external/zlib/*.h
%{_includedir}/%{name}/filtering/*.h
%{_includedir}/%{name}/general_hash/*.h
%{_includedir}/%{name}/geometry/*.h
%{_includedir}/%{name}/global_optimization/*.h
%{_includedir}/%{name}/graph/*.h
%{_includedir}/%{name}/graph_cuts/*.h
%{_includedir}/%{name}/graph_utils/*.h
%{_includedir}/%{name}/gui_core/*.h
%{_includedir}/%{name}/gui_widgets/*.h
%{_includedir}/%{name}/hash_map/*.h
%{_includedir}/%{name}/hash_set/*.h
%{_includedir}/%{name}/hash_table/*.h
%{_includedir}/%{name}/http_client/*.h
%{_includedir}/%{name}/image_keypoint/*.h
%{_includedir}/%{name}/image_loader/*.h
%{_includedir}/%{name}/image_processing/*.h
%{_includedir}/%{name}/image_saver/*.h
%{_includedir}/%{name}/image_transforms/*.h
%{_includedir}/%{name}/interfaces/*.h
%{_includedir}/%{name}/iosockstream/*.h
%{_includedir}/%{name}/java/*.h
%{_includedir}/%{name}/linker/*.h
%{_includedir}/%{name}/logger/*.h
%{_includedir}/%{name}/lsh/*.h
%{_includedir}/%{name}/lz77_buffer/*.h
%{_includedir}/%{name}/lzp_buffer/*.h
%{_includedir}/%{name}/matlab/*.h
%{_includedir}/%{name}/manifold_regularization/*.h
%{_includedir}/%{name}/map/*.h
%{_includedir}/%{name}/math/*.h
%{_includedir}/%{name}/math/details/*.h
%{_includedir}/%{name}/matrix/*.h
%{_includedir}/%{name}/matrix/lapack/*.h
%{_includedir}/%{name}/md5/*.h
%{_includedir}/%{name}/member_function_pointer/*.h
%{_includedir}/%{name}/memory_manager/*.h
%{_includedir}/%{name}/memory_manager_global/*.h
%{_includedir}/%{name}/memory_manager_stateless/*.h
%{_includedir}/%{name}/misc_api/*.h
%{_includedir}/%{name}/mlp/*.h
%{_includedir}/%{name}/numerical_integration/*.h
%{_includedir}/%{name}/opencv/*.h
%{_includedir}/%{name}/optimization/*.h
%{_includedir}/%{name}/pipe/*.h
%{_includedir}/%{name}/python/*.h
%{_includedir}/%{name}/quantum_computing/*.h
%{_includedir}/%{name}/queue/*.h
%{_includedir}/%{name}/rand/*.h
%{_includedir}/%{name}/random_forest/*.h
%{_includedir}/%{name}/reference_counter/*.h
%{_includedir}/%{name}/sequence/*.h
%{_includedir}/%{name}/server/*.h
%{_includedir}/%{name}/set/*.h
%{_includedir}/%{name}/set_utils/*.h
%{_includedir}/%{name}/simd/*.h
%{_includedir}/%{name}/sliding_buffer/*.h
%{_includedir}/%{name}/smart_pointers/*.h
%{_includedir}/%{name}/sockets/*.h
%{_includedir}/%{name}/sockstreambuf/*.h
%{_includedir}/%{name}/sqlite/*.h
%{_includedir}/%{name}/stack/*.h
%{_includedir}/%{name}/static_map/*.h
%{_includedir}/%{name}/static_set/*.h
%{_includedir}/%{name}/statistics/*.h
%{_includedir}/%{name}/stl_checked/*.h
%{_includedir}/%{name}/string/*
%{_includedir}/%{name}/svm/*.h
%{_includedir}/%{name}/sync_extension/*.h
%{_includedir}/%{name}/test/*.h
%{_includedir}/%{name}/timeout/*.h
%{_includedir}/%{name}/timer/*.h
%{_includedir}/%{name}/threads/*.h
%{_includedir}/%{name}/tokenizer/*.h
%{_includedir}/%{name}/tuple/*.h
%{_includedir}/%{name}/type_safe_union/*.h
%{_includedir}/%{name}/unicode/*.h
%{_includedir}/%{name}/vectorstream/*.h
%{_includedir}/%{name}/xml_parser/*.h
%{_includedir}/%{name}/cassert
%{_includedir}/%{name}/cstring
%{_includedir}/%{name}/locale
%{_includedir}/%{name}/fstream
%{_includedir}/%{name}/iomanip
%{_includedir}/%{name}/iosfwd
%{_includedir}/%{name}/iostream
%{_includedir}/%{name}/istream
%{_includedir}/%{name}/ostream
%{_includedir}/%{name}/sstream
%{_includedir}/%{name}/*.txt
%{_libdir}/lib%{name}.so
%{_libdir}/cmake/%{name}/*.cmake
%{_libdir}/pkgconfig/%{name}-1.pc

#=============================================================================
%package		-n python3-%{name}
Summary		:	Python 3 interface to %{name}

#-----------------------------------------------------------------------------
Requires	:	%{name}	= %{version}-%{release}

#----------------------------------------------------------------------------
%description		-n python3-%{name}
Dlib is a general purpose cross-platform open source
software library written in the C++ programming language.
This package contains Python 3 API for the library.

#-----------------------------------------------------------------------------
%files			-n python3-%{name}
%defattr(-, root,root,-)
%license dlib/LICENSE.txt
%license python_examples/LICENSE_FOR_EXAMPLE_PROGRAMS.txt
%{python3_sitearch}/_%{name}_pybind11%{python3_ext_suffix}
%{python3_sitearch}/%{name}/
%{python3_sitearch}/%{name}-*.egg-info/

#=============================================================================
%package		doc
Summary		:	Documentation for dlib

#-----------------------------------------------------------------------------
Requires	:	%{name}	= %{version}-%{release}

BuildArch	:	noarch
#----------------------------------------------------------------------------
%description		doc
Dlib is a general purpose cross-platform open source
software library written in the C++ programming language.
This package contains the library documentation and examples.

#-----------------------------------------------------------------------------
%files			doc
%defattr(-,root,root,-)
%license examples/LICENSE_FOR_EXAMPLE_PROGRAMS.txt
%license examples/video_frames/license.txt
#doc documentation.html
%doc docs
#doc docs/python/_static/{jquery,underscore}.js
%doc examples

#=============================================================================
%prep
%setup -q

#-----------------------------------------------------------------------------
#building application
%build

cmake							\
	-B bld						\
	-G Ninja					\
	-D CMAKE_INSTALL_PREFIX=%{_prefix}		\
	-D CMAKE_INSTALL_LIBDIR=%{_libdir}		\
	-D BUILD_SHARED_LIBS=ON				\
	-D CMAKE_BUILD_TYPE=Release			\
	-D USE_AVX_INSTRUCTIONS=OFF			\
	-D USE_SSE4_INSTRUCTIONS=OFF			\
	-D DLIB_USE_CUDA=OFF				\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
ninja							\
	-C bld						\
	%{_smp_mflags}

%{__python}						\
	setup.py					\
	--no USE_SSE4_INSTRUCTIONS			\
	--no USE_AVX_INSTRUCTIONS			\
	build						\
	

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

DESTDIR=%{buildroot} ninja				\
	-C bld						\
	install

%{__python}						\
	setup.py					\
	install						\
	--skip-build					\
	--no-compile					\
	--root %{buildroot}				\

#-----------------------------------------------------------------------------
%changelog
